*,
*::before,
*::after {
    box-sizing: border-box;
}

:root {
    --th-primary: #1a4b76;
    --hover-color: #ce4330;
    --dark-gray: #999;
    --light-gray: #ccc;
    --line-color: #f3f3f3;
    --minor-font-size: 0.875rem;
    --compact-gap: 10px;
    --markdown-gap: 15px;
    --loose-gap: 30px;
}

@font-face {
    font-family: Saira;
    font-style: normal;
    font-weight: 400;
    font-display: swap;
    src:
        local("Saira Regular"),
        local("Saira-Regular"),
        url(/assets/Saira.woff2) format("woff2");
}

@font-face {
    font-family: JetBrainsMono;
    font-style: normal;
    font-weight: 400;
    font-display: swap;
    src:
        local("JetBrainsMono Light"),
        local("JetBrainsMono-Light"),
        url(/assets/JetBrainsMono.woff2) format("woff2");
}

html {
    scroll-padding-top: 90px;
    font-size: 16px;
}

body {
    margin: 0;
    color: #333;
    font-family:
        Saira,
        -apple-system,
        BlinkMacSystemFont,
        "PingFang SC",
        "Microsoft YaHei",
        "Noto Sans CJK SC",
        Helvetica,
        Arial,
        sans-serif;
    line-height: 1.8;
    overflow-x: hidden;
}

/* ------------------------------------------------------------ Override */

h1,
h2,
h3,
h4,
h5,
h6 {
    margin: 0;
    font-weight: 500;
}

h1,
h2,
h3 {
    line-height: 1.5;
}

h6 {
    line-height: 1.6;
}

h1 {
    font-size: 2.2rem;
}

h2 {
    font-size: 1.8rem;
}

h3 {
    font-size: 1.6rem;
}

h4 {
    font-size: 1.4rem;
}

h5 {
    font-size: 1.2rem;
}

h6 {
    font-size: 0.9rem;
}

a {
    color: var(--th-primary);
    cursor: pointer;
    text-decoration: none;
    transition: all 0.3s;
}

a:hover {
    color: var(--hover-color);
    text-decoration: underline;
}

hr {
    height: 1px;
    border: 0;
    background: var(--line-color);
    margin: var(--loose-gap) 0;
}

img {
    display: block;
    max-width: 100%;
    border-radius: 8px;
}

video {
    display: block;
    max-width: 100%;
    border-radius: 8px;
}

/* ------------------------------------------------------------ Header */

header {
    position: sticky;
    z-index: 1;
    top: 0;
    height: 70px;
    box-shadow: 0 0 var(--compact-gap) 0 rgba(0, 0, 0, 0.1);
    background: rgba(255, 255, 255, 0.6);
    backdrop-filter: blur(var(--compact-gap));
}

header > div {
    display: flex;
    justify-content: space-between;
    align-items: center;
    gap: var(--compact-gap);
    padding: 0 var(--loose-gap);
    margin: 0 auto;
    max-width: 960px;
    height: 100%;
}

header .logo {
    display: flex;
    align-items: center;
    height: 28px;
    font-size: 32px;
    font-weight: 700;
    color: var(--hover-color);
    text-decoration: none;
    user-select: none;
}

header .logo img {
    height: 100%;
}

header a.hamburger {
    display: none;
    align-items: center;
    padding: var(--compact-gap);
}

/* ------------------------------------------------------------ Search */

.search-box {
    flex: 1;
    display: flex;
    justify-content: flex-end;
    align-items: center;
    margin-left: var(--compact-gap);
}

.search-box input {
    outline: none;
    border: 1px solid var(--line-color);
    border-radius: 15px;
    padding: 6px 12px;
    font-size: var(--minor-font-size);
    font-family: inherit;
    width: 150px;
    color: #333;
    background: transparent;
    transition: all 0.3s;
}

.search-box input:focus {
    border-color: var(--light-gray);
    width: 100%;
}

/* ------------------------------------------------------------ Navigation */

nav {
    display: flex;
    color: var(--th-primary);
    gap: var(--compact-gap);
}

nav.active {
    transform: translateX(0);
}

menu {
    position: relative;
    margin: 0;
    padding: var(--compact-gap);
    font-weight: 500;
    white-space: nowrap;
}

menu > * {
    display: flex;
    align-items: center;
    gap: 5px;
    cursor: pointer;
}

menu .dropdown {
    display: none;
    position: absolute;
    z-index: 2;
    right: 0;
    top: 100%;
    width: max-content;
    padding: 8px 0;
    background: #fff;
    box-shadow: 0 0 var(--compact-gap) 0 rgba(0, 0, 0, 0.1);
    white-space: nowrap;
}

menu:hover .dropdown {
    display: block;
}

menu .dropdown > a {
    display: flex;
    align-items: center;
    gap: 5px;
    padding: 5px 20px;
    color: #666;
    font-size: var(--minor-font-size);
}

menu .dropdown > a:hover {
    background: var(--line-color);
    color: var(--hover-color);
    text-decoration: none;
}

menu .dropdown > hr {
    margin: 5px 0;
}

/* ------------------------------------------------------------ Main */

main {
    max-width: 960px;
    margin: auto;
    padding: 0 var(--loose-gap);
}

article,
section {
    margin: var(--loose-gap) 0;
}

article > h6 {
    display: flex;
    flex-wrap: wrap;
    gap: 0 var(--compact-gap);
    color: var(--light-gray);
    margin-top: 5px;
    word-wrap: break-word;
}

article > h6 > a {
    color: inherit;
}

article.paginator {
    display: flex;
    justify-content: center;
    gap: var(--compact-gap);
    font-size: var(--minor-font-size);
}

article.paginator > a {
    display: flex;
    justify-content: center;
    align-items: center;
    border: 1px solid var(--line-color);
    border-radius: 5px;
    min-width: 32px;
    height: 32px;
    padding: 0 8px;
    text-decoration: none;
}

article.paginator > a:hover {
    color: inherit;
    border-color: var(--th-primary);
}

article.paginator > a.current {
    color: var(--light-gray);
    background: var(--line-color);
}

/* ------------------------------------------------------------ Footer */

footer {
    text-align: center;
    font-size: var(--minor-font-size);
    padding: var(--loose-gap);
    background: var(--line-color);
    color: var(--light-gray);
}

footer a {
    color: var(--dark-gray);
}

footer img {
    display: inline-block;
}

/* ------------------------------------------------------------ Editor */

.edit-form {
    display: flex;
    gap: var(--compact-gap);
    flex-wrap: wrap;
}

.edit-form > th-field,
.edit-form > th-select {
    flex: 1;
}

.edit-form + .edit-form {
    margin: var(--compact-gap) 0;
}

.edit-form th-field:has(th-switch) {
    flex: none;
    width: 140px;
}

.edit-form th-field:has(th-switch)::part(label) {
    min-width: 65px;
}

.edit-form th-field[type="textarea"] {
    margin: var(--compact-gap) 0;
}

.btn-group {
    display: flex;
    justify-content: flex-end;
    gap: var(--compact-gap);
}

/* ------------------------------------------------------------ Markdown */

.markdown {
    margin-top: var(--loose-gap);
}

.markdown p,
.markdown hr,
.markdown blockquote,
.markdown pre {
    margin: var(--markdown-gap) 0;
}

.markdown blockquote {
    padding-left: var(--markdown-gap);
    border-left: 3px solid #ddd;
    color: var(--dark-gray);
}

.markdown pre {
    border-radius: 5px;
    padding: var(--compact-gap) var(--markdown-gap);
    background: var(--line-color);
    font-size: var(--minor-font-size);
    font-family: JetBrainsMono, ui-monospace, monospace;
    overflow: auto;
}

.markdown code {
    font-family: inherit;
}

.markdown :not(pre) code {
    border-radius: 5px;
    margin: 5px;
    padding: 5px 10px;
    font-size: var(--minor-font-size);
    background: var(--line-color);
}

.markdown b,
.markdown i,
.markdown em,
.markdown strong {
    font-weight: 500;
}

.markdown b {
    color: #0ca4e1;
}

.markdown i {
    color: var(--light-gray);
}

.markdown em {
    color: #0ca4e1;
}

.markdown strong {
    font-style: italic;
    color: #3fb960;
}

.markdown em strong {
    font-style: normal;
    color: var(--hover-color);
}

.markdown del {
    color: var(--dark-gray);
}

.markdown .image-container {
    display: flex;
    flex-direction: column;
    align-items: center;
}

.markdown .image-caption {
    border-bottom: 1px solid #ddd;
    color: var(--dark-gray);
    font-size: 0.8125rem;
    padding: 8px 0 4px;
}

/* ------------------------------------------------------------ Common */

.overlay {
    position: fixed;
    background: rgba(0, 0, 0, 0.3);
    inset: 0;
    opacity: 0;
    pointer-events: none;
    transition: opacity 0.2s;
}

.overlay.active {
    opacity: 1;
    pointer-events: auto;
}

.divider {
    width: 60px;
    height: 2px;
    background: var(--hover-color);
    margin: var(--loose-gap) auto;
}

.icon {
    width: 24px;
    height: 24px;
    filter: brightness(0%) invert(70%);
}

.icon.tiny {
    width: 8px;
    height: 8px;
}

.error-panel {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    height: 63.5vh;
}

.error-panel .error-code {
    font-size: 7em;
    font-weight: 700;
    color: var(--line-color);
    line-height: 1;
    letter-spacing: 8px;
}

.error-panel .error-message {
    font-size: 1.1em;
    color: var(--dark-gray);
}

.error-panel .error-home {
    margin-top: 30px;
    padding: 8px 28px;
    border-radius: 20px;
    border: 1px solid var(--light-gray);
    font-size: var(--minor-font-size);
    color: var(--dark-gray);
    transition: all 0.3s;
}

.error-panel .error-home:hover {
    border-color: var(--hover-color);
    color: var(--hover-color);
    text-decoration: none;
}

.headline {
    display: flex;
    justify-content: space-between;
    align-items: center;
}

.wordcount {
    color: var(--light-gray);
    font-size: var(--minor-font-size);
    margin-left: var(--compact-gap);
}

.not-found {
    text-align: center;
    color: var(--dark-gray);
}

/* ------------------------------------------------------------ Responsive */

@media (max-width: 800px) {
    header > div {
        padding-right: var(--compact-gap);
    }
    header a.hamburger {
        display: flex;
    }
    nav {
        flex-direction: column;
        position: fixed;
        background: #fff;
        top: 70px;
        right: 0;
        padding: var(--loose-gap) 0;
        width: 180px;
        gap: 0;
        box-shadow: 0 0 var(--compact-gap) 0 rgba(0, 0, 0, 0.1);
        transition: transform 0.2s;
        transform: translateX(105%);
    }
    menu {
        padding: 0;
    }
    menu > * {
        padding: 5px 40px;
    }
    menu > a:hover {
        text-decoration: none;
        background: var(--line-color);
    }
    menu .dropdown {
        display: block;
        position: initial;
        box-shadow: none;
        width: auto;
        padding: 0;
    }
    menu .dropdown > a {
        padding: 5px 54px;
    }
}

@media (max-width: 480px) {
    html {
        font-size: 17px;
    }
}
